// Generated by CoffeeScript 1.10.0
(function() {
  var MigrationDescription;

  MigrationDescription = (function() {
    function MigrationDescription(modelFrom, modelTo) {
      this.modelFrom = modelFrom;
      this.modelTo = modelTo;
      this.entitiesChanges = [];
      this.attributesChanges = {};
      this.relationshipsChanges = {};
      this.scriptsBefore = [];
      this.scriptsAfter = [];
    }

    MigrationDescription.prototype.addEntity = function(name) {
      return this.entitiesChanges.push({
        entity: name,
        change: '+'
      });
    };

    MigrationDescription.prototype.renameEntity = function(oldName, newName) {
      return this.entitiesChanges.push({
        entity: oldName,
        change: newName
      });
    };

    MigrationDescription.prototype.removeEntity = function(name) {
      return this.entitiesChanges.push({
        entity: name,
        change: '-'
      });
    };

    MigrationDescription.prototype.addAttribute = function(entityName, name) {
      this.attributesChanges[entityName] = this.attributesChanges[entityName] || {};
      return this.attributesChanges[entityName][name] = '+';
    };

    MigrationDescription.prototype.renameAttribute = function(entityName, oldName, newName) {
      this.attributesChanges[entityName] = this.attributesChanges[entityName] || {};
      return this.attributesChanges[entityName][newName] = oldName;
    };

    MigrationDescription.prototype.removeAttribute = function(entityName, name) {
      this.attributesChanges[entityName] = this.attributesChanges[entityName] || {};
      return this.attributesChanges[entityName][name] = '-';
    };

    MigrationDescription.prototype.addRelationship = function(entityName, name) {
      this.relationshipsChanges[entityName] = this.relationshipsChanges[entityName] || {};
      return this.relationshipsChanges[entityName][name] = '+';
    };

    MigrationDescription.prototype.renameRelationship = function(entityName, oldName, newName) {
      this.relationshipsChanges[entityName] = this.relationshipsChanges[entityName] || {};
      return this.relationshipsChanges[entityName][newName] = oldName;
    };

    MigrationDescription.prototype.removeRelationship = function(entityName, name) {
      this.relationshipsChanges[entityName] = this.relationshipsChanges[entityName] || {};
      return this.relationshipsChanges[entityName][name] = '-';
    };

    MigrationDescription.prototype.addScriptBefore = function(script) {
      return this.scriptsBefore.push(script);
    };

    MigrationDescription.prototype.addScriptAfter = function(script) {
      return this.scriptsAfter.push(script);
    };

    return MigrationDescription;

  })();

  module.exports = MigrationDescription;

}).call(this);
